--- net/minecraft/src/Explosion.java
+++ net/minecraft/src/Explosion.java
@@ -3,126 +3,163 @@
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.List;
+import java.util.Random;
+import java.util.Set;
 
 public class Explosion {
-	public void doExplosion(World var1, Entity var2, double var3, double var5, double var7, float var9) {
-		var1.playSoundEffect(var3, var5, var7, "random.explode", 4.0F, (1.0F + (var1.rand.nextFloat() - var1.rand.nextFloat()) * 0.2F) * 0.7F);
-		HashSet var10 = new HashSet();
-		float var11 = var9;
-		byte var12 = 16;
-
-		int var13;
-		int var14;
-		int var15;
-		double var25;
-		double var27;
-		double var29;
-		for(var13 = 0; var13 < var12; ++var13) {
-			for(var14 = 0; var14 < var12; ++var14) {
-				for(var15 = 0; var15 < var12; ++var15) {
-					if(var13 == 0 || var13 == var12 - 1 || var14 == 0 || var14 == var12 - 1 || var15 == 0 || var15 == var12 - 1) {
-						double var16 = (double)((float)var13 / ((float)var12 - 1.0F) * 2.0F - 1.0F);
-						double var18 = (double)((float)var14 / ((float)var12 - 1.0F) * 2.0F - 1.0F);
-						double var20 = (double)((float)var15 / ((float)var12 - 1.0F) * 2.0F - 1.0F);
-						double var22 = Math.sqrt(var16 * var16 + var18 * var18 + var20 * var20);
-						var16 /= var22;
-						var18 /= var22;
-						var20 /= var22;
-						float var24 = var9 * (0.7F + var1.rand.nextFloat() * 0.6F);
-						var25 = var3;
-						var27 = var5;
-						var29 = var7;
-
-						for(float var31 = 0.3F; var24 > 0.0F; var24 -= var31 * (12.0F / 16.0F)) {
-							int var32 = MathHelper.floor_double(var25);
-							int var33 = MathHelper.floor_double(var27);
-							int var34 = MathHelper.floor_double(var29);
-							int var35 = var1.getBlockId(var32, var33, var34);
-							if(var35 > 0) {
-								var24 -= (Block.blocksList[var35].getExplosionResistance(var2) + 0.3F) * var31;
-							}
-
-							if(var24 > 0.0F) {
-								var10.add(new ChunkPosition(var32, var33, var34));
-							}
-
-							var25 += var16 * (double)var31;
-							var27 += var18 * (double)var31;
-							var29 += var20 * (double)var31;
+	public boolean isFlaming = false;
+	private Random ExplosionRNG = new Random();
+	private World worldObj;
+	public double explosionX;
+	public double explosionY;
+	public double explosionZ;
+	public Entity exploder;
+	public float explosionSize;
+	public Set destroyedBlockPositions = new HashSet();
+	
+	public Explosion(World var1, Entity var2, double var3, double var5, double var7, float var9) {
+		this.worldObj = var1;
+		this.exploder = var2;
+		this.explosionSize = var9;
+		this.explosionX = var3;
+		this.explosionY = var5;
+		this.explosionZ = var7;
+	}
+
+	public void doExplosionA() {
+		float var1 = this.explosionSize;
+		byte var2 = 16;
+
+		int var3;
+		int var4;
+		int var5;
+		double var15;
+		double var17;
+		double var19;
+		for(var3 = 0; var3 < var2; ++var3) {
+			for(var4 = 0; var4 < var2; ++var4) {
+				for(var5 = 0; var5 < var2; ++var5) {
+					if(var3 == 0 || var3 == var2 - 1 || var4 == 0 || var4 == var2 - 1 || var5 == 0 || var5 == var2 - 1) {
+						double var6 = (double)((float)var3 / ((float)var2 - 1.0F) * 2.0F - 1.0F);
+						double var8 = (double)((float)var4 / ((float)var2 - 1.0F) * 2.0F - 1.0F);
+						double var10 = (double)((float)var5 / ((float)var2 - 1.0F) * 2.0F - 1.0F);
+						double var12 = Math.sqrt(var6 * var6 + var8 * var8 + var10 * var10);
+						var6 /= var12;
+						var8 /= var12;
+						var10 /= var12;
+						float var14 = this.explosionSize * (0.7F + this.worldObj.rand.nextFloat() * 0.6F);
+						var15 = this.explosionX;
+						var17 = this.explosionY;
+						var19 = this.explosionZ;
+
+						for(float var21 = 0.3F; var14 > 0.0F; var14 -= var21 * (12.0F / 16.0F)) {
+							int var22 = MathHelper.floor_double(var15);
+							int var23 = MathHelper.floor_double(var17);
+							int var24 = MathHelper.floor_double(var19);
+							int var25 = this.worldObj.getBlockId(var22, var23, var24);
+							if(var25 > 0) {
+								var14 -= (Block.blocksList[var25].getExplosionResistance(this.exploder) + 0.3F) * var21;
+							}
+
+							if(var14 > 0.0F) {
+								this.destroyedBlockPositions.add(new ChunkPosition(var22, var23, var24));
+							}
+
+							var15 += var6 * (double)var21;
+							var17 += var8 * (double)var21;
+							var19 += var10 * (double)var21;
 						}
 					}
 				}
 			}
 		}
 
-		var9 *= 2.0F;
-		var13 = MathHelper.floor_double(var3 - (double)var9 - 1.0D);
-		var14 = MathHelper.floor_double(var3 + (double)var9 + 1.0D);
-		var15 = MathHelper.floor_double(var5 - (double)var9 - 1.0D);
-		int var45 = MathHelper.floor_double(var5 + (double)var9 + 1.0D);
-		int var17 = MathHelper.floor_double(var7 - (double)var9 - 1.0D);
-		int var46 = MathHelper.floor_double(var7 + (double)var9 + 1.0D);
-		List var19 = var1.getEntitiesWithinAABBExcludingEntity(var2, AxisAlignedBB.getBoundingBoxFromPool((double)var13, (double)var15, (double)var17, (double)var14, (double)var45, (double)var46));
-		Vec3D var47 = Vec3D.createVector(var3, var5, var7);
-
-		double var55;
-		double var56;
-		double var57;
-		for(int var21 = 0; var21 < var19.size(); ++var21) {
-			Entity var49 = (Entity)var19.get(var21);
-			double var23 = var49.getDistance(var3, var5, var7) / (double)var9;
-			if(var23 <= 1.0D) {
-				var25 = var49.posX - var3;
-				var27 = var49.posY - var5;
-				var29 = var49.posZ - var7;
-				var55 = (double)MathHelper.sqrt_double(var25 * var25 + var27 * var27 + var29 * var29);
-				var25 /= var55;
-				var27 /= var55;
-				var29 /= var55;
-				var56 = (double)var1.getBlockDensity(var47, var49.boundingBox);
-				var57 = (1.0D - var23) * var56;
-				var49.attackEntityFrom(var2, (int)((var57 * var57 + var57) / 2.0D * 8.0D * (double)var9 + 1.0D));
-				var49.motionX += var25 * var57;
-				var49.motionY += var27 * var57;
-				var49.motionZ += var29 * var57;
-			}
-		}
-
-		var9 = var11;
-		ArrayList var48 = new ArrayList();
-		var48.addAll(var10);
-
-		for(int var50 = var48.size() - 1; var50 >= 0; --var50) {
-			ChunkPosition var51 = (ChunkPosition)var48.get(var50);
-			int var52 = var51.x;
-			int var53 = var51.y;
-			int var26 = var51.z;
-			int var54 = var1.getBlockId(var52, var53, var26);
-
-			for(int var28 = 0; var28 < 1; ++var28) {
-				var29 = (double)((float)var52 + var1.rand.nextFloat());
-				var55 = (double)((float)var53 + var1.rand.nextFloat());
-				var56 = (double)((float)var26 + var1.rand.nextFloat());
-				var57 = var29 - var3;
-				double var37 = var55 - var5;
-				double var39 = var56 - var7;
-				double var41 = (double)MathHelper.sqrt_double(var57 * var57 + var37 * var37 + var39 * var39);
-				var57 /= var41;
-				var37 /= var41;
-				var39 /= var41;
-				double var43 = 0.5D / (var41 / (double)var9 + 0.1D);
-				var43 *= (double)(var1.rand.nextFloat() * var1.rand.nextFloat() + 0.3F);
-				var57 *= var43;
-				var37 *= var43;
-				var39 *= var43;
-				var1.spawnParticle("explode", (var29 + var3 * 1.0D) / 2.0D, (var55 + var5 * 1.0D) / 2.0D, (var56 + var7 * 1.0D) / 2.0D, var57, var37, var39);
-				var1.spawnParticle("smoke", var29, var55, var56, var57, var37, var39);
-			}
-
-			if(var54 > 0) {
-				Block.blocksList[var54].dropBlockAsItemWithChance(var1, var52, var53, var26, var1.getBlockMetadata(var52, var53, var26), 0.3F);
-				var1.setBlockWithNotify(var52, var53, var26, 0);
-				Block.blocksList[var54].onBlockDestroyedByExplosion(var1, var52, var53, var26);
+		this.explosionSize *= 2.0F;
+		var3 = MathHelper.floor_double(this.explosionX - (double)this.explosionSize - 1.0D);
+		var4 = MathHelper.floor_double(this.explosionX + (double)this.explosionSize + 1.0D);
+		var5 = MathHelper.floor_double(this.explosionY - (double)this.explosionSize - 1.0D);
+		int var29 = MathHelper.floor_double(this.explosionY + (double)this.explosionSize + 1.0D);
+		int var7 = MathHelper.floor_double(this.explosionZ - (double)this.explosionSize - 1.0D);
+		int var30 = MathHelper.floor_double(this.explosionZ + (double)this.explosionSize + 1.0D);
+		List var9 = this.worldObj.getEntitiesWithinAABBExcludingEntity(this.exploder, AxisAlignedBB.getBoundingBoxFromPool((double)var3, (double)var5, (double)var7, (double)var4, (double)var29, (double)var30));
+		Vec3D var31 = Vec3D.createVector(this.explosionX, this.explosionY, this.explosionZ);
+
+		for(int var11 = 0; var11 < var9.size(); ++var11) {
+			Entity var33 = (Entity)var9.get(var11);
+			double var13 = var33.getDistance(this.explosionX, this.explosionY, this.explosionZ) / (double)this.explosionSize;
+			if(var13 <= 1.0D) {
+				var15 = var33.posX - this.explosionX;
+				var17 = var33.posY - this.explosionY;
+				var19 = var33.posZ - this.explosionZ;
+				double var39 = (double)MathHelper.sqrt_double(var15 * var15 + var17 * var17 + var19 * var19);
+				var15 /= var39;
+				var17 /= var39;
+				var19 /= var39;
+				double var40 = (double)this.worldObj.getBlockDensity(var31, var33.boundingBox);
+				double var41 = (1.0D - var13) * var40;
+				var33.attackEntityFrom(this.exploder, (int)((var41 * var41 + var41) / 2.0D * 8.0D * (double)this.explosionSize + 1.0D));
+				var33.motionX += var15 * var41;
+				var33.motionY += var17 * var41;
+				var33.motionZ += var19 * var41;
+			}
+		}
+
+		this.explosionSize = var1;
+		ArrayList var32 = new ArrayList();
+		var32.addAll(this.destroyedBlockPositions);
+		if(this.isFlaming) {
+			for(int var34 = var32.size() - 1; var34 >= 0; --var34) {
+				ChunkPosition var35 = (ChunkPosition)var32.get(var34);
+				int var36 = var35.x;
+				int var37 = var35.y;
+				int var16 = var35.z;
+				int var38 = this.worldObj.getBlockId(var36, var37, var16);
+				int var18 = this.worldObj.getBlockId(var36, var37 - 1, var16);
+				if(var38 == 0 && Block.opaqueCubeLookup[var18] && this.ExplosionRNG.nextInt(3) == 0) {
+					this.worldObj.setBlockWithNotify(var36, var37, var16, Block.fire.blockID);
+				}
+			}
+		}
+
+	}
+
+	public void doExplosionB(boolean var1) {
+		if (!this.worldObj.multiplayerWorld)
+			this.worldObj.playSoundEffect(this.explosionX, this.explosionY, this.explosionZ, "random.explode", 4.0F, (1.0F + (this.worldObj.rand.nextFloat() - this.worldObj.rand.nextFloat()) * 0.2F) * 0.7F);
+
+		ArrayList var2 = new ArrayList();
+		var2.addAll(this.destroyedBlockPositions);
+
+		for(int var3 = var2.size() - 1; var3 >= 0; --var3) {
+			ChunkPosition var4 = (ChunkPosition)var2.get(var3);
+			int var5 = var4.x;
+			int var6 = var4.y;
+			int var7 = var4.z;
+			int var8 = this.worldObj.getBlockId(var5, var6, var7);
+			if(var1) {
+				double var9 = (double)((float)var5 + this.worldObj.rand.nextFloat());
+				double var11 = (double)((float)var6 + this.worldObj.rand.nextFloat());
+				double var13 = (double)((float)var7 + this.worldObj.rand.nextFloat());
+				double var15 = var9 - this.explosionX;
+				double var17 = var11 - this.explosionY;
+				double var19 = var13 - this.explosionZ;
+				double var21 = (double)MathHelper.sqrt_double(var15 * var15 + var17 * var17 + var19 * var19);
+				var15 /= var21;
+				var17 /= var21;
+				var19 /= var21;
+				double var23 = 0.5D / (var21 / (double)this.explosionSize + 0.1D);
+				var23 *= (double)(this.worldObj.rand.nextFloat() * this.worldObj.rand.nextFloat() + 0.3F);
+				var15 *= var23;
+				var17 *= var23;
+				var19 *= var23;
+				this.worldObj.spawnParticle("explode", (var9 + this.explosionX * 1.0D) / 2.0D, (var11 + this.explosionY * 1.0D) / 2.0D, (var13 + this.explosionZ * 1.0D) / 2.0D, var15, var17, var19);
+				this.worldObj.spawnParticle("smoke", var9, var11, var13, var15, var17, var19);
+			}
+
+			if(var8 > 0) {
+				Block.blocksList[var8].dropBlockAsItemWithChance(this.worldObj, var5, var6, var7, this.worldObj.getBlockMetadata(var5, var6, var7), 0.3F);
+				this.worldObj.setBlockWithNotify(var5, var6, var7, 0);
+				Block.blocksList[var8].onBlockDestroyedByExplosion(this.worldObj, var5, var6, var7);
 			}
 		}
 
--- /dev/null
+++ net/minecraft/src/Packet71Weather.java
@@ -1,0 +1,40 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet71Weather extends Packet {
+	public int field_27054_a;
+	public int field_27053_b;
+	public int field_27057_c;
+	public int field_27056_d;
+	public int field_27055_e;
+
+	public Packet71Weather() {
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_27054_a = var1.readInt();
+		this.field_27055_e = var1.readByte();
+		this.field_27053_b = var1.readInt();
+		this.field_27057_c = var1.readInt();
+		this.field_27056_d = var1.readInt();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.field_27054_a);
+		var1.writeByte(this.field_27055_e);
+		var1.writeInt(this.field_27053_b);
+		var1.writeInt(this.field_27057_c);
+		var1.writeInt(this.field_27056_d);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleWeather(this);
+	}
+
+	public int getPacketSize() {
+		return 17;
+	}
+}
--- net/minecraft/src/BlockChest.java
+++ net/minecraft/src/BlockChest.java
@@ -143,7 +143,7 @@
 					}
 
 					var7.stackSize -= var11;
-					EntityItem var12 = new EntityItem(var1, (double)((float)var2 + var8), (double)((float)var3 + var9), (double)((float)var4 + var10), new ItemStack(var7.itemID, var11, var7.itemDmg));
+					EntityItem var12 = new EntityItem(var1, (double)((float)var2 + var8), (double)((float)var3 + var9), (double)((float)var4 + var10), new ItemStack(var7.itemID, var11, var7.getItemDamage()));
 					float var13 = 0.05F;
 					var12.motionX = (double)((float)this.random.nextGaussian() * var13);
 					var12.motionY = (double)((float)this.random.nextGaussian() * var13 + 0.2F);
@@ -185,6 +185,10 @@
 				var6 = new InventoryLargeChest("Large chest", (IInventory)var6, (TileEntityChest)var1.getBlockTileEntity(var2, var3, var4 + 1));
 			}
 
+
+			if (var1.multiplayerWorld)
+				return true;
+			
 			var5.displayGUIChest((IInventory)var6);
 			return true;
 		}
--- /dev/null
+++ net/minecraft/src/Packet131MapData.java
@@ -1,0 +1,37 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet131MapData extends Packet {
+	public short field_28055_a;
+	public short field_28054_b;
+	public byte[] field_28056_c;
+
+	public Packet131MapData() {
+		this.isChunkDataPacket = true;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_28055_a = var1.readShort();
+		this.field_28054_b = var1.readShort();
+		this.field_28056_c = new byte[var1.readByte() & 255];
+		var1.readFully(this.field_28056_c);
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeShort(this.field_28055_a);
+		var1.writeShort(this.field_28054_b);
+		var1.writeByte(this.field_28056_c.length);
+		var1.write(this.field_28056_c);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_28116_a(this);
+	}
+
+	public int getPacketSize() {
+		return 4 + this.field_28056_c.length;
+	}
+}
--- net/minecraft/src/EntityFX.java
+++ net/minecraft/src/EntityFX.java
@@ -50,6 +50,9 @@
 		return this;
 	}
 
+	protected void entityInit() {
+	}
+
 	public void onUpdate() {
 		this.prevPosX = this.posX;
 		this.prevPosY = this.posY;
--- net/minecraft/src/WorldClient.java
+++ net/minecraft/src/WorldClient.java
@@ -130,7 +130,13 @@
 	}
 
 	public void addEntityToWorld(int var1, Entity var2) {
+		Entity var3 = this.getEntityByID(var1);
+		if(var3 != null) {
+			this.setEntityDead(var3);
+		}
+		
 		this.entityList.add(var2);
+		var2.entityID = var1;
 		if(!this.spawnEntityInWorld(var2)) {
 			this.entitySpawnQueue.add(var2);
 		}
@@ -202,6 +208,6 @@
 	}
 
 	public void sendQuittingDisconnectingPacket() {
-		this.sendQueue.addToSendQueue(new Packet255KickDisconnect("Quitting"));
+		this.sendQueue.func_28117_a(new Packet255KickDisconnect("Quitting"));
 	}
 }
--- net/minecraft/src/EntityOtherPlayerMP.java
+++ net/minecraft/src/EntityOtherPlayerMP.java
@@ -95,4 +95,18 @@
 		this.cameraYaw += (var9 - this.cameraYaw) * 0.4F;
 		this.cameraPitch += (var2 - this.cameraPitch) * 0.8F;
 	}
+
+	public void outfitWithItem(int var1, int var2, int var3) {
+		ItemStack var4 = null;
+		if(var2 >= 0) {
+			var4 = new ItemStack(var2, 1, var3);
+		}
+
+		if(var1 == 0) {
+			this.inventory.mainInventory[this.inventory.currentItem] = var4;
+		} else {
+			this.inventory.armorInventory[var1 - 1] = var4;
+		}
+
+	}
 }
--- net/minecraft/src/EntityDiggingFX.java
+++ net/minecraft/src/EntityDiggingFX.java
@@ -1,9 +1,9 @@
 package net.minecraft.src;
 
 public class EntityDiggingFX extends EntityFX {
-	public EntityDiggingFX(World var1, double var2, double var4, double var6, double var8, double var10, double var12, Block var14) {
+	public EntityDiggingFX(World var1, double var2, double var4, double var6, double var8, double var10, double var12, Block var14, int metadata) {
 		super(var1, var2, var4, var6, var8, var10, var12);
-		this.particleTextureIndex = var14.blockIndexInTexture;
+		this.particleTextureIndex = var14.getBlockTextureFromSideAndMetadata(2, metadata);
 		this.particleGravity = var14.blockParticleGravity;
 		this.particleRed = this.particleGreen = this.particleBlue = 0.6F;
 		this.particleScale /= 2.0F;
--- /dev/null
+++ net/minecraft/src/Packet106Transaction.java
@@ -1,0 +1,40 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet106Transaction extends Packet {
+	public int windowId;
+	public short field_20028_b;
+	public boolean field_20030_c;
+
+	public Packet106Transaction() {
+	}
+
+	public Packet106Transaction(int var1, short var2, boolean var3) {
+		this.windowId = var1;
+		this.field_20028_b = var2;
+		this.field_20030_c = var3;
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20089_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+		this.field_20028_b = var1.readShort();
+		this.field_20030_c = var1.readByte() != 0;
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+		var1.writeShort(this.field_20028_b);
+		var1.writeByte(this.field_20030_c ? 1 : 0);
+	}
+
+	public int getPacketSize() {
+		return 4;
+	}
+}
--- net/minecraft/src/PlayerControllerSP.java
+++ net/minecraft/src/PlayerControllerSP.java
@@ -28,9 +28,9 @@
 		ItemStack var8 = this.mc.thePlayer.getCurrentEquippedItem();
 		boolean var9 = this.mc.thePlayer.canHarvestBlock(Block.blocksList[var5]);
 		if(var8 != null) {
-			var8.onDestroyBlock(var5, var1, var2, var3);
+			var8.onDestroyBlock(var5, var1, var2, var3, this.mc.thePlayer);
 			if(var8.stackSize == 0) {
-				var8.onItemDestroyedByUse(this.mc.thePlayer);
+				var8.func_1097_a(this.mc.thePlayer);
 				this.mc.thePlayer.destroyCurrentEquippedItem();
 			}
 		}
@@ -43,6 +43,7 @@
 	}
 
 	public void clickBlock(int var1, int var2, int var3, int var4) {
+		this.mc.theWorld.extinguishFire(this.mc.thePlayer, var1, var2, var3, var4);
 		int var5 = this.mc.theWorld.getBlockId(var1, var2, var3);
 		if(var5 > 0 && this.curBlockDamage == 0.0F) {
 			Block.blocksList[var5].onBlockClicked(this.mc.theWorld, var1, var2, var3, this.mc.thePlayer);
@@ -72,7 +73,7 @@
 				Block var6 = Block.blocksList[var5];
 				this.curBlockDamage += var6.blockStrength(this.mc.thePlayer);
 				if(this.blockDestroySoundCounter % 4.0F == 0.0F && var6 != null) {
-					this.mc.sndManager.playSound(var6.stepSound.getStepSound(), (float)var1 + 0.5F, (float)var2 + 0.5F, (float)var3 + 0.5F, (var6.stepSound.getVolume() + 1.0F) / 8.0F, var6.stepSound.getPitch() * 0.5F);
+					this.mc.sndManager.playSound(var6.stepSound.getBreakSound(), (float)var1 + 0.5F, (float)var2 + 0.5F, (float)var3 + 0.5F, (var6.stepSound.getVolume() + 1.0F) / 8.0F, var6.stepSound.getPitch() * 0.5F);
 				}
 
 				++this.blockDestroySoundCounter;
@@ -98,11 +99,11 @@
 	public void setPartialTime(float var1) {
 		if(this.curBlockDamage <= 0.0F) {
 			this.mc.ingameGUI.damageGuiPartialTime = 0.0F;
-			this.mc.renderGlobal.damagePartialTime = 0.0F;
+			//this.mc.renderGlobal.damagePartialTime = 0.0F;
 		} else {
 			float var2 = this.prevBlockDamage + (this.curBlockDamage - this.prevBlockDamage) * var1;
 			this.mc.ingameGUI.damageGuiPartialTime = var2;
-			this.mc.renderGlobal.damagePartialTime = var2;
+			//this.mc.renderGlobal.damagePartialTime = var2;
 		}
 
 	}
--- net/minecraft/src/TileEntityMobSpawner.java
+++ net/minecraft/src/TileEntityMobSpawner.java
@@ -26,52 +26,55 @@
 			for(this.yaw += (double)(1000.0F / ((float)this.delay + 200.0F)); this.yaw > 360.0D; this.prevYaw -= 360.0D) {
 				this.yaw -= 360.0D;
 			}
-
-			if(this.delay == -1) {
-				this.updateDelay();
-			}
-
-			if(this.delay > 0) {
-				--this.delay;
-			} else {
-				byte var7 = 4;
-
-				for(int var8 = 0; var8 < var7; ++var8) {
-					EntityLiving var9 = (EntityLiving)((EntityLiving)EntityList.createEntityByName(this.mobID, this.worldObj));
-					if(var9 == null) {
-						return;
-					}
-
-					int var10 = this.worldObj.getEntitiesWithinAABB(var9.getClass(), AxisAlignedBB.getBoundingBoxFromPool((double)this.xCoord, (double)this.yCoord, (double)this.zCoord, (double)(this.xCoord + 1), (double)(this.yCoord + 1), (double)(this.zCoord + 1)).expand(8.0D, 4.0D, 8.0D)).size();
-					if(var10 >= 6) {
-						this.updateDelay();
-						return;
-					}
-
-					if(var9 != null) {
-						double var11 = (double)this.xCoord + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4.0D;
-						double var13 = (double)(this.yCoord + this.worldObj.rand.nextInt(3) - 1);
-						double var15 = (double)this.zCoord + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4.0D;
-						var9.setLocationAndAngles(var11, var13, var15, this.worldObj.rand.nextFloat() * 360.0F, 0.0F);
-						if(var9.getCanSpawnHere()) {
-							this.worldObj.spawnEntityInWorld(var9);
-
-							for(int var17 = 0; var17 < 20; ++var17) {
-								var1 = (double)this.xCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
-								var3 = (double)this.yCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
-								var5 = (double)this.zCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
-								this.worldObj.spawnParticle("smoke", var1, var3, var5, 0.0D, 0.0D, 0.0D);
-								this.worldObj.spawnParticle("flame", var1, var3, var5, 0.0D, 0.0D, 0.0D);
-							}
-
-							var9.spawnExplosionParticle();
+			
+
+			if(!this.worldObj.multiplayerWorld) {
+				if(this.delay == -1) {
+					this.updateDelay();
+				}
+
+				if(this.delay > 0) {
+					--this.delay;
+				} else {
+					byte var7 = 4;
+
+					for(int var8 = 0; var8 < var7; ++var8) {
+						EntityLiving var9 = (EntityLiving)((EntityLiving)EntityList.createEntityByName(this.mobID, this.worldObj));
+						if(var9 == null) {
+							return;
+						}
+
+						int var10 = this.worldObj.getEntitiesWithinAABB(var9.getClass(), AxisAlignedBB.getBoundingBoxFromPool((double)this.xCoord, (double)this.yCoord, (double)this.zCoord, (double)(this.xCoord + 1), (double)(this.yCoord + 1), (double)(this.zCoord + 1)).expand(8.0D, 4.0D, 8.0D)).size();
+						if(var10 >= 6) {
 							this.updateDelay();
+							return;
+						}
+
+						if(var9 != null) {
+							double var11 = (double)this.xCoord + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4.0D;
+							double var13 = (double)(this.yCoord + this.worldObj.rand.nextInt(3) - 1);
+							double var15 = (double)this.zCoord + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4.0D;
+							var9.setLocationAndAngles(var11, var13, var15, this.worldObj.rand.nextFloat() * 360.0F, 0.0F);
+							if(var9.getCanSpawnHere()) {
+								this.worldObj.spawnEntityInWorld(var9);
+
+								for(int var17 = 0; var17 < 20; ++var17) {
+									var1 = (double)this.xCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
+									var3 = (double)this.yCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
+									var5 = (double)this.zCoord + 0.5D + ((double)this.worldObj.rand.nextFloat() - 0.5D) * 2.0D;
+									this.worldObj.spawnParticle("smoke", var1, var3, var5, 0.0D, 0.0D, 0.0D);
+									this.worldObj.spawnParticle("flame", var1, var3, var5, 0.0D, 0.0D, 0.0D);
+								}
+
+								var9.spawnExplosionParticle();
+								this.updateDelay();
+							}
 						}
 					}
 				}
-
-				super.updateEntity();
 			}
+
+			super.updateEntity();
 		}
 	}
 
--- /dev/null
+++ net/minecraft/src/Packet101CloseWindow.java
@@ -1,0 +1,32 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet101CloseWindow extends Packet {
+	public int windowId;
+
+	public Packet101CloseWindow() {
+	}
+
+	public Packet101CloseWindow(int var1) {
+		this.windowId = var1;
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20092_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+	}
+
+	public int getPacketSize() {
+		return 1;
+	}
+}
--- net/minecraft/src/ItemRecord.java
+++ net/minecraft/src/ItemRecord.java
@@ -1,7 +1,7 @@
 package net.minecraft.src;
 
 public class ItemRecord extends Item {
-	private String recordName;
+	public final String recordName;
 
 	protected ItemRecord(int var1, String var2) {
 		super(var1);
@@ -11,6 +11,9 @@
 
 	public boolean onItemUse(ItemStack var1, EntityPlayer var2, World var3, int var4, int var5, int var6, int var7) {
 		if(var3.getBlockId(var4, var5, var6) == Block.jukebox.blockID && var3.getBlockMetadata(var4, var5, var6) == 0) {
+			if(var3.multiplayerWorld)
+				return true;
+
 			var3.setBlockMetadataWithNotify(var4, var5, var6, this.shiftedIndex - Item.record13.shiftedIndex + 1);
 			var3.playRecord(this.recordName, var4, var5, var6);
 			--var1.stackSize;
--- net/minecraft/src/AxisAlignedBB.java
+++ net/minecraft/src/AxisAlignedBB.java
@@ -191,11 +191,29 @@
 		return this;
 	}
 
+	public boolean contains(Vec3D vec) {
+		if (vec.xCoord <= this.minX || vec.xCoord >= this.maxX) {
+			return false;
+		} else {
+			return vec.yCoord <= this.minY || vec.yCoord >= this.maxY ? false : !(vec.zCoord <= this.minZ) && !(vec.zCoord >= this.maxZ);
+		}
+	}
+
 	public double getAverageEdgeLength() {
 		double var1 = this.maxX - this.minX;
 		double var3 = this.maxY - this.minY;
 		double var5 = this.maxZ - this.minZ;
 		return (var1 + var3 + var5) / 3.0D;
+	}
+
+	public AxisAlignedBB contract(double dx, double dy, double dz) {
+		double d = this.minX + dx;
+		double e = this.minY + dy;
+		double f = this.minZ + dz;
+		double g = this.maxX - dx;
+		double h = this.maxY - dy;
+		double i = this.maxZ - dz;
+		return getBoundingBoxFromPool(d, e, f, g, h, i);
 	}
 
 	public AxisAlignedBB copy() {
--- /dev/null
+++ net/minecraft/src/ContainerWorkbench.java
@@ -1,0 +1,91 @@
+package net.minecraft.src;
+
+public class ContainerWorkbench extends Container {
+	public InventoryCrafting craftMatrix = new InventoryCrafting(this, 3, 3);
+	public IInventory craftResult = new InventoryCraftResult();
+	private World field_20133_c;
+	private int field_20132_h;
+	private int field_20131_i;
+	private int field_20130_j;
+
+	public ContainerWorkbench(InventoryPlayer var1, World var2, int var3, int var4, int var5) {
+		this.field_20133_c = var2;
+		this.field_20132_h = var3;
+		this.field_20131_i = var4;
+		this.field_20130_j = var5;
+		this.addSlot(new SlotCrafting(var1.player, this.craftMatrix, this.craftResult, 0, 124, 35));
+
+		int var6;
+		int var7;
+		for(var6 = 0; var6 < 3; ++var6) {
+			for(var7 = 0; var7 < 3; ++var7) {
+				this.addSlot(new Slot(this.craftMatrix, var7 + var6 * 3, 30 + var7 * 18, 17 + var6 * 18));
+			}
+		}
+
+		for(var6 = 0; var6 < 3; ++var6) {
+			for(var7 = 0; var7 < 9; ++var7) {
+				this.addSlot(new Slot(var1, var7 + var6 * 9 + 9, 8 + var7 * 18, 84 + var6 * 18));
+			}
+		}
+
+		for(var6 = 0; var6 < 9; ++var6) {
+			this.addSlot(new Slot(var1, var6, 8 + var6 * 18, 142));
+		}
+
+		this.onCraftMatrixChanged(this.craftMatrix);
+	}
+
+	public void onCraftMatrixChanged(IInventory var1) {
+		this.craftResult.setInventorySlotContents(0, CraftingManager.getInstance().findMatchingRecipe(this.craftMatrix));
+	}
+
+	public void onCraftGuiClosed(EntityPlayer var1) {
+		super.onCraftGuiClosed(var1);
+		if(!this.field_20133_c.multiplayerWorld) {
+			for(int var2 = 0; var2 < 9; ++var2) {
+				ItemStack var3 = this.craftMatrix.getStackInSlot(var2);
+				if(var3 != null) {
+					var1.dropPlayerItem(var3);
+				}
+			}
+
+		}
+	}
+
+	public boolean isUsableByPlayer(EntityPlayer var1) {
+		return this.field_20133_c.getBlockId(this.field_20132_h, this.field_20131_i, this.field_20130_j) != Block.workbench.blockID ? false : var1.getDistanceSq((double)this.field_20132_h + 0.5D, (double)this.field_20131_i + 0.5D, (double)this.field_20130_j + 0.5D) <= 64.0D;
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		ItemStack var2 = null;
+		Slot var3 = (Slot)this.slots.get(var1);
+		if(var3 != null && var3.getHasStack()) {
+			ItemStack var4 = var3.getStack();
+			var2 = var4.copy();
+			if(var1 == 0) {
+				this.func_28125_a(var4, 10, 46, true);
+			} else if(var1 >= 10 && var1 < 37) {
+				this.func_28125_a(var4, 37, 46, false);
+			} else if(var1 >= 37 && var1 < 46) {
+				this.func_28125_a(var4, 10, 37, false);
+			} else {
+				this.func_28125_a(var4, 10, 46, false);
+			}
+
+			if(var4.stackSize == 0) {
+				var3.putStack((ItemStack)null);
+			} else {
+				var3.onSlotChanged();
+			}
+
+			if(var4.stackSize == var2.stackSize) {
+				return null;
+			}
+
+			var3.onPickupFromSlot(var4);
+		}
+
+		return var2;
+	}
+}
--- net/minecraft/src/Packet34EntityTeleport.java
+++ net/minecraft/src/Packet34EntityTeleport.java
@@ -33,7 +33,7 @@
 		this.pitch = (byte)var1.read();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
